package com.nisum.paymentvendorsimulator.creditcard.controllers;

import com.nisum.paymentvendorsimulator.creditcard.domain.dto.CreditCardRequest;
import com.nisum.paymentvendorsimulator.creditcard.domain.dto.CreditCardResponse;
import com.nisum.paymentvendorsimulator.creditcard.services.CreditCardService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("/api/cc")
@CrossOrigin(origins = "*")
public class CreditCardController {

  private static final Logger logger = LoggerFactory.getLogger(CreditCardController.class);

  @Autowired
  CreditCardService ccService;

  @PostMapping(value = "/authorize", consumes = MediaType.APPLICATION_JSON_VALUE, produces = MediaType.APPLICATION_JSON_VALUE)
  public CreditCardResponse authorize(@RequestBody CreditCardRequest ccRequest) {
    logger.info("this is CC controller");
    return ccService.authorize(ccRequest);
  }

}
